<script lang="ts">
  import { onMount } from 'svelte';
  import { browser } from '$app/environment';
  import { Anchor, Node, Svelvet, Edge } from 'svelvet';
  import { Badge, Sidebar, SidebarWrapper, Button, Modal } from 'flowbite-svelte';
  import Fa from 'svelte-fa';
  import { faXmark, faCircleQuestion, faAnglesRight } from '@fortawesome/free-solid-svg-icons';
  import SidebarNodeDetail from '$lib/proxiplay/SidebarNodeDetail.svelte';
  import EventFilter from '$lib/filters/EventFilter.svelte';
  import { EngagementData } from '$lib/data/engagementData';
  import { page } from '$app/stores';
  import { findKnownTag, knownTags } from '$lib/tags';
  import Tag from '$lib/Tag.svelte';
  import { pushState } from '$app/navigation';
  import { derived } from 'svelte/store';
  import type { Competition } from '@types';
  import { nodeInfo } from 'virtual:precomputed-nodes';
  import { useLocalStorage } from 'sveltronics';

  let showHelp = useLocalStorage('proxiplayHelp', true);
  let open = false;
  let theme = 'dark';
  let mapWidth = 0;
  let mapHeight = 0;
  let sidebarCollapsed = false;
  let activeNode = derived(
    page,
    // get activeNode from shallowRouting state first, then from URL (normal routing)
    (p) => p.state.activeNode || p.url.searchParams.get('node'),
    $page.url.searchParams.get('node') || null
  );
  let events = Object.values(EngagementData.data.competitions);
  $: visibleNodes = getFilteredNodes(events);

  function getFilteredNodes(selectedEvents: Competition[]) {
    const selectedEventNames = selectedEvents.map((e) => {
      return e.name;
    });
    console.log(selectedEventNames);
    const filtered = nodeInfo.filter((node) => {
      return selectedEventNames.includes(node.data['name']);
    });
    console.log(filtered);
    return filtered;
  }

  function setActiveNode(node: string | null) {
    if (node) {
      $page.url.searchParams.set('node', node);
      sidebarCollapsed = false;
    } else {
      $page.url.searchParams.delete('node');
      sidebarCollapsed = true;
    }

    // wrap tracker code in try/catch to prevent errors from breaking the app
    try {
      if (browser && window?.umami) {
        if (node) window.umami.track('Node Selected', { node });
        else window.umami.track('Deselect Node', { node: activeNode });
      }
    } finally {
      pushState($page.url.href, { activeNode: node });
    }
  }

  function getInitialPosition() {
    let maxParticipation = 0;
    let targetNode = null;
    if ($activeNode) {
      targetNode = $activeNode;
    } else {
      // If no active node, then find the one with the highest participation
      for (const [event, participants] of Object.entries(EngagementData.data.participation)) {
        if (maxParticipation < participants) {
          maxParticipation = participants;
          targetNode = event;
        }
      }
    }
    const n = nodeInfo.find((e) => e.data['name'] == targetNode);
    // This is really dumb, the initial translation appears to need a negation for
    // reasons I don't understand, otherwise it goes the opposite direction of the
    // node. When the translation is complete, it leaves the node targeted in the top
    // left corner, so to center it, a modification by the width of the map needs to
    // be tracked. This function needs to be run after the DOM is initialized so
    // the width is known, the svelte if below handles that.
    return { x: -(n.position.x - mapWidth / 2), y: -(n.position.y - mapHeight / 2) };
  }

  onMount(() => {
    visibleNodes = nodeInfo;
    if (browser) theme = document.documentElement.getAttribute('svelvet-theme') || theme;
    open = $showHelp;
  });
</script>

<!-- Help modal -->
<Modal bind:open title="Help">
  <div class="flex flex-col px-10 text-left">
    <ul style="list-style: inside;">
      <li>Click a node to view event details</li>
      <li>Use the filters in the top left to narrow results</li>
      <li>If having trouble panning the map, try locking node movement using the lock icon in the bottom left</li>
      <li>
        Map nodes are sized according to the engagement with the CAE community, the exact number is displayed at the top
        of the event details
      </li>
      <li>Connections between nodes are bolder when more commonality is shared</li>
      <li>Not all connections between nodes are represented due to performance</li>
    </ul>
  </div>
  <div slot="footer" class="flex flex-row w-full py-4 px-4">
    <div class="relative w-full">
      <Button
        class="mr-auto"
        data-umami-event="Never show Help Dialog"
        on:click={() => {
          showHelp.set(false);
          open = false;
        }}>Don't show this again</Button>
      <Button
        class="absolute inset-y-0 right-0"
        data-umami-event="Hide Help Dialog"
        on:click={() => {
          open = false;
        }}>Dismiss</Button>
    </div>
  </div>
</Modal>

<div class="flex-grow h-full">
  <div
    bind:clientWidth={mapWidth}
    bind:clientHeight={mapHeight}
    class="flex-grow w-full h-full"
    style="contain: content;">
    <div class="absolute z-40 max-w-5xl">
      <EventFilter class="m-2" collapsed bind:events />
    </div>
    <button
      class="absolute top-2 right-2 z-40"
      data-umami-event="Show Help Dialog"
      on:click={() => {
        open = true;
      }}
      type="button">
      <Fa
        icon={faCircleQuestion}
        size="2x"
        class="float-right shadow-x1 text-white rounded-full bg-gray-800 border border-lite-extra-gray/25 shadow-xl dark:text-medium-extra-gray dark:bg-white" />
    </button>
    <!-- Wait for these to be defined so panning to the middle is possible -->
    {#if mapWidth && mapHeight}
      <Svelvet {theme} zoom={1} translation={getInitialPosition()} minimap controls>
        {#each visibleNodes as info (info.id)}
          <Node
            editable={false}
            on:nodeClicked={() => {
              setActiveNode(info.data['name']);
            }}
            id={info.id}
            position={info.position}
            label="{info.id} - {info.data['type'] || 'noType'} - {info.data['name'] || 'noName'}"
            width={info.width}
            height={info.height}
            useDefaults={true}
            bgColor={$activeNode == info.data['name'] ? 'lightslategray' : null}
            borderColor={findKnownTag(info.data['tags'])?.color || 'dimgray'}
            borderWidth="0.4em">
            <div style="flex-direction: column; text-align: center;">
              <p>{info.data['name'] || 'noName'}</p>
            </div>
            {#each info.connections as conn}
              {#if $activeNode == info.data['name'] && conn.data.type == 'TAG_SHARED'}
                <Anchor invisible={true} dynamic={true} connections={[conn.target]}>
                  <Edge
                    slot="edge"
                    width={$activeNode == info.data['name'] ? conn.data.tags.length : 0.1}
                    animate={$activeNode == info.data['name']}
                    label={$activeNode == info.data['name'] ? conn.data.tags : null} />
                </Anchor>
              {/if}
            {/each}
            <Anchor invisible={true} dynamic={true} />
          </Node>
        {/each}
      </Svelvet>
    {/if}
    <div class="absolute bottom-2 left-12">
      <div class="grid md:grid-cols-3 sm:grid-cols-1 items-center gap-2">
        {#each knownTags as tag}
          <Tag tag={tag.name} />
        {/each}
      </div>
    </div>
    {#if $activeNode}
      <Sidebar
        asideClass="bg-slate-50 dark:bg-gray-800
          border border-slate-600/25
          shadow-xl {sidebarCollapsed ? 'hidden' : ''}
          md:w-1/3 sm:w-auto h-4/5 z-50"
        style="position: fixed; top: 0; right: 0; overflow: auto;">
        <SidebarWrapper class="h-full dark:text-white rounded-none">
          <div class="flex mb-2">
            <span class="flex mb-2 items-center gap-4">
              <Badge>{EngagementData.data.participation[$activeNode] || 0} active CAE institutions</Badge>
            </span>
            <Button
              color="transparent"
              class="ml-auto rounded-lg p-1.5 focus:outline-none whitespace-normal focus:ring-2 focus:ring-gray-400 bg-gray-100 dark:bg-gray-600"
              data-umami-event="Collapse Sidebar"
              on:click={() => {
                sidebarCollapsed = true;
              }}>
              <Fa size="lg" icon={faAnglesRight} />
            </Button>
            <Button
              color="transparent"
              class="ml-2 rounded-lg p-1.5 focus:outline-none whitespace-normal focus:ring-2 focus:ring-gray-400 bg-gray-100 dark:bg-gray-600"
              data-umami-event="Close Sidebar"
              on:click={() => setActiveNode(null)}>
              <Fa class="px-0.5" size="lg" icon={faXmark} />
            </Button>
          </div>
          <SidebarNodeDetail name={$activeNode} data={EngagementData.data.competitions[$activeNode]} />
        </SidebarWrapper>
      </Sidebar>
    {/if}
  </div>
</div>
